//import java.util.Map;

class Cactus {
  String axiom = "FX";
  String computedWord;
  String [][] rules = {
    {"X", "FX", "FX", "FX", "FX", "FX", "FX", "FX", "FX", "FX", "FX", "FX",
     "F[+++S-S-SX][---S+S+SX][FX]", "F[+++S-S-SX][FX]", "F[---S+S+SX][FX]"},
    {"F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F"},
    {"S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S"},
    {"+", "+", "+", "+", "+", "+", "+", "+", "+", "+", "+", "+", "+", "+", "+"},
    {"-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-"},
    {"[", "[", "[", "[", "[", "[", "[", "[", "[", "[", "[", "[", "[", "[", "["},
    {"]", "]", "]", "]", "]", "]", "]", "]", "]", "]", "]", "]", "]", "]", "]"},
  };
//  Map <String, String> rules = new HashMap<String, String>();
  int iterations;
  float size, angle, scale;
  
  Cactus(float size, float angle, float scale) {
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    computedWord = axiom;
    iterations = 0;
  }
  
  void reset() {
    this.computedWord = this.axiom;
    this.iterations = 0;
  }
  
  void iteration() {
    iterations++;
    char s;
    String newWord = "";
    // loop through computedWord
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      // for every symbol, check if a rule applies
      for (int j=0; j<rules.length; j++) {
        if (s==rules[j][0].charAt(0)) {
          // replace symbol according to rule
          //newWord = newWord + rules[j][1];
          newWord = newWord + rules[j][(int)random(1, 15)];
          break;
        }
      }
    }
    computedWord = newWord;
    println(iterations + ": " + computedWord);
  }
  
  void drawCactus(Turtle t) {
    float scaledSize = size * pow(scale, iterations);
    // loop through computedWord and draw each symbol
    char s;
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      
      float heading = t.getHeading();
      if (heading > 0) {
        t.setHeading(heading - 2);
      } else if(heading < 0) {
        t.setHeading(heading + 2);
      }

      if(s == 'F') {
        t.right(random(-0.5, 0.5));
        t.push();
        stroke(360, 0, 100);
        strokeWeight(22);
        t.forward(scaledSize);
        t.pop();
        stroke(91, 22, 72);
        strokeWeight(20);
        t.forward(-2);
        t.forward(2);
        t.forward(scaledSize);
    } else if(s == 'X') {
        if(random(0, 1) > 0.5) {
          fill(360, 99, 58);
          stroke(360, 99, 77);
          strokeWeight(1);
          float ellipseSize = random(10, 14);
          ellipse(t.getX(), t.getY(), ellipseSize, ellipseSize*2);
          ellipse(t.getX(), t.getY(), ellipseSize*2, ellipseSize);
          t.right(90);
          t.forward(1);
          t.right(90);
          t.forward(1);
          fill(360, 99, 77);
          ellipse(t.getX(), t.getY(), ellipseSize-3, ellipseSize-3);
        }
      } else if(s=='S') {
        t.push();
        stroke(360, 0, 100);
        strokeWeight(22);
        t.forward(scaledSize/3);
        t.pop();
        stroke(91, 22, 72);
        strokeWeight(20);
        t.forward(-2);
        t.forward(2);
        t.forward(scaledSize/3);
      } else if(s == '+') {
        t.right(angle+random(-1, 1));
      } else if(s == '-') {
        t.left(angle+random(-1, 1));
      } else if(s == '[') {
        t.push();
      } else if(s == ']') {
        t.pop();
      }
    }
  }
}
