//import java.util.Map;

class Koch {
  String axiom = "F";
  String computedWord;
  String [][] rules = { {"F", "F-F++F-F"}, {"+", "+"}, {"-", "-"} };
//  Map <String, String> rules = new HashMap<String, String>();
  int iterations;
  float size, angle, scale;
  
  Koch(float size, float angle, float scale) {
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    computedWord = axiom;
    iterations = 0;
    
  }
  
  void iteration() {
    iterations++;
    size = size * scale;
    char s;
    String newWord = "";
    // loop through computedWord
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      // for every symbol, check if a rule applies
      for (int j=0; j<rules.length; j++) {
        if (s==rules[j][0].charAt(0)) {
          // replace symbol according to rule
          newWord = newWord + rules[j][1];
          break;
        }
      }
    }
    computedWord = newWord;    
    //println(iterations + ": " + computedWord);
  }
  
  void drawKoch(Turtle t) {
    // loop through computedWord and draw each symbol
    char s;
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if(s == 'F') {
        t.forward(size);
      } else if(s == '+') {
        t.right(angle);
      } else if(s == '-') {
        t.left(angle);
      }
    }
  }
}
