import Turtle.*;
Turtle t;
Pearls pearl;
Willow willow;
Cactus cactus;

int mycolor = #0077AD;

String mode = "pearl";

void setup() {
  size(1000, 700);
  background(mycolor);
  stroke(255);

  t = new Turtle(this);
  colorMode(HSB);
  pearl = new Pearls(height-20, 20, 0.9);
  willow = new Willow(height-20, 10, 0.4, true);
  cactus = new Cactus(height-20, 30, 0.5);
  frameRate(20);

  //drawLSystem();
}

void draw() {
  drawLSystem();
}

void drawLSystem() {
  t.setX(width/2);
  if (mode=="pearl") {
    t.setY(10);
    t.setHeading(180);
    background(mycolor);
    pearl.drawPearls(t);
  } else if (mode=="willow") {
    t.setY(height-10);
    t.setHeading(0);
    background(mycolor);
    willow.drawWillow(t);
  } else if (mode=="cactus") {
    t.setY(height-10);
    t.setHeading(0);
    background(mycolor);
    cactus.drawCactus(t);
  }
}

void mousePressed() {
  if (mode=="pearl") {
    pearl.iteration();
  } else if (mode=="willow") {
    willow.iteration();
  } else if (mode=="cactus") {
    cactus.iteration();
  }
  //drawLSystem();
}

void keyPressed() {
  if (key==' ') {
  String filename = mode+random(0, 100)+".png";
  save(filename);
  println("Saved File: "+filename);
  } else if (keyCode==UP) {
    if (mode=="pearl") {
      pearl.scale = pearl.scale + 0.005;
      println(pearl.scale);
    } else if (mode=="willow") {
      willow.scale = willow.scale + 0.005;
      println(willow.scale);
    } else if (mode=="cactus") {
      cactus.scale = cactus.scale + 0.005;
      println(cactus.scale);
    }
    //drawLSystem();
  } else if (keyCode==DOWN) {
    if (mode=="pearl") {
      pearl.scale = pearl.scale - 0.005;
      println(pearl.scale);
    } else if (mode=="willow") {
      willow.scale = willow.scale - 0.005;
      println(willow.scale);
    } else if (mode=="cactus") {
      cactus.scale = cactus.scale - 0.005;
      println(cactus.scale);
    }
    //drawLSystem();
  } else if (key=='p') {
    mode = "pearl";
    pearl.reset();
    //drawLSystem();
  } else if (key=='w') {
    mode = "willow";
    willow.reset();
    //drawLSystem();
  } else if (key=='c') {
    mode = "cactus";
    cactus.reset();
    //drawLSystem();
  }
}
