//import java.util.Map;

class Pearls {
  String axiom = "FX";
  String computedWord;
  String [][] rules = {
    {"X", "F[+++P]X", "F[++P]X", "F[---P]X", "FX[--P]",
     "F[+++P]X", "F[++P]X", "F[---P]X", "FX[--P]", "F[+++S-S-S-X][---S+S+S+X]"},
    {"F", "F", "F", "F", "F", "F", "F", "F", "F", "F"},
    {"P", "P", "P", "P", "P", "P", "P", "P", "P", "P"},
    {"S", "S", "S", "S", "S", "S", "S", "S", "S", "S"},
    {"+", "+", "+", "+", "+", "+", "+", "+", "+", "+"},
    {"-", "-", "-", "-", "-", "-", "-", "-", "-", "-"},
    {"[", "[", "[", "[", "[", "[", "[", "[", "[", "["},
    {"]", "]", "]", "]", "]", "]", "]", "]", "]", "]"},
  };
//  Map <String, String> rules = new HashMap<String, String>();
  int iterations;
  float size, angle, scale;
  
  Pearls(float size, float angle, float scale) {
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    computedWord = axiom;
    iterations = 0;
  }
  
  void reset() {
    this.computedWord = this.axiom;
    this.iterations = 0;
  }
  
  void iteration() {
    iterations++;
    char s;
    String newWord = "";
    // loop through computedWord
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      // for every symbol, check if a rule applies
      for (int j=0; j<rules.length; j++) {
        if (s==rules[j][0].charAt(0)) {
          // replace symbol according to rule
          //newWord = newWord + rules[j][1];
          newWord = newWord + rules[j][(int)random(1, 10)];
          break;
        }
      }
    }
    computedWord = newWord;
    println(iterations + ": " + computedWord);
  }
  
  void drawPearls(Turtle t) {
    float scaledSize = size * pow(scale, iterations);
    // loop through computedWord and draw each symbol
    char s;
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if(s == 'F') {
        t.right(random(-0.5, 0.5));
        stroke(119, 60, 99);
        strokeWeight(2);
        t.forward(scaledSize);
      } else if(s == 'X') {
        fill(119, 99, 58);
        stroke(119, 99, 77);
        strokeWeight(1);
        float ellipseSize = random(10, 14);
        ellipse(t.getX(), t.getY(), ellipseSize, ellipseSize);
        t.right(90);
        t.forward(1);
        t.right(90);
        t.forward(1);
        fill(119, 99, 77);
        ellipse(t.getX(), t.getY(), ellipseSize-3, ellipseSize-3);
      } else if(s=='S') {
        stroke(119, 60, 99);
        strokeWeight(2);
        t.forward(scaledSize/4);
      } else if(s == 'P') {
        stroke(119, 60, 99);
        strokeWeight(1);
        t.forward(scaledSize/8);
        fill(119, 99, 58);
        stroke(119, 99, 77);
        float ellipseSize = random(10, 14);
        ellipse(t.getX(), t.getY(), ellipseSize, ellipseSize);
        t.right(90);
        t.forward(1);
        t.right(90);
        t.forward(1);
        fill(119, 99, 77);
        ellipse(t.getX(), t.getY(), ellipseSize-3, ellipseSize-3);
      } else if(s == '+') {
        t.right(angle+random(-1, 1));
      } else if(s == '-') {
        t.left(angle+random(-1, 1));
      } else if(s == '[') {
        t.push();
      } else if(s == ']') {
        t.pop();
      }
    }
  }
}
