class Pine {
  String axiom = "FX";
  String computedWord;
  String [][] rules = {
    {"F", "FF", "FF", "F", "FFF"},
    {"X", "FX[--X+][FX]", "FX[--X+][++X-]", "FX[++X-][FX]", "FX[++X-][--X+]"},
    {"+", "+", "+", "+", "+"},
    {"-", "-", "-", "-", "-"}, 
    {"[", "[", "[", "[", "["},
    {"]", "]", "]", "]", "]"}, 
  };
  int iterations;
  float size, angle, scale;

  Pine(float size, float angle, float scale) {
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    computedWord = axiom;
    iterations = 0;
    colorMode(HSB, 360, 100, 100);
  }
  
  void reset() {
    this.computedWord = this.axiom;
    this.iterations = 0;
  }
  
  void iteration() {
    iterations++;
    char s;
    String newWord = "";
    // loop through computedWord
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      // for every symbol, check if a rule applies
      for (int j=0; j<rules.length; j++) {
        if (s==rules[j][0].charAt(0)) {
          // replace symbol according to rule
          //newWord = newWord + rules[j][1];
          newWord = newWord + rules[j][(int)random(1, 5)];
          break;
        }
      }
    }
    computedWord = newWord;    
    //println(iterations + ": " + computedWord);
  }
  
  void drawPine(Turtle t) {
    float strokeWidth = 20;
    float scaledSize = size * pow(scale, iterations);
    // loop through computedWord and draw each symbol
    char s;
    stroke(22, 29, 80);
    strokeWeight(1);
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if(s == 'F') {
        //stroke(22, 29, int(80 - strokeWidth*1.2));
        //strokeWeight(strokeWidth);
        t.right(random(-0.5, 0.5));
        t.forward(scaledSize);
      } else if(s == 'X') {
        // draw leaves
      } else if(s == '+') {
        t.right(angle+random(-0.5, 0.5));
      } else if(s == '-') {
        t.left(angle+random(-0.5, 0.5));
      } else if(s == '[') {
        strokeWidth = strokeWidth / 1.5;
        if (strokeWidth <= 1) {
          strokeWidth = 1;
        }
        t.push();
      } else if(s == ']') {
        strokeWidth = strokeWidth * 1.5;
        if (strokeWidth >= 20) {
          strokeWidth = 20;
        }
        t.pop();
      }
    }
  }
}
