class Tree {
  String axiom = "X";
  String computedWord;
  String [][] rules = {
    {"F", "FF", "FF", "FFF", "F"}, 
    {"X", "F[+X][-X]", "F[+X][-X]", "F[+X][-X][FX]", "F[+X][-X]"},
    {"+", "+", "+", "+", "+"},
    {"-", "-", "-", "-", "-"}, 
    {"[", "[", "[", "[", "["},
    {"]", "]", "]", "]", "]"}, 
  };
  int iterations;
  float size, angle, scale;
  
  Tree(float size, float angle, float scale) {
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    computedWord = axiom;
    iterations = 0;
  }
  
  void iteration() {
    iterations++;
    size = size * scale;
    char s;
    String newWord = "";
    // loop through computedWord
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      // for every symbol, check if a rule applies
      for (int j=0; j<rules.length; j++) {
        if (s==rules[j][0].charAt(0)) {
          // replace symbol according to rule
          //newWord = newWord + rules[j][1];
          newWord = newWord + rules[j][(int)random(1, 5)];
          break;
        }
      }
    }
    computedWord = newWord;    
    //println(iterations + ": " + computedWord);
  }
  
  void drawTree(Turtle t) {
    // loop through computedWord and draw each symbol
    char s;
    for (int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if(s == 'F') {
        t.right(random(-0.5, 0.5));
        t.forward(size);
      } else if(s == '+') {
        t.right(random(-0.5, 0.5));
        t.right(angle);
      } else if(s == '-') {
        t.right(random(-0.5, 0.5));
        t.left(angle);
      } else if(s == '[') {
        t.push();
      } else if(s == ']') {
        t.pop();
      } else if(s == 'X') {
        fill(255, 0, 0);
        ellipse(t.getX(), t.getY(), 5, 5);
      }
    }
  }
}
